TwinCAT Übersicht

TwinCAT System ist das Verbindungselement zwischen Windows NT und TwinCAT. Vom TwinCAT System wird beispielsweise der TwinCAT Start während des Systemstarts von Windows NT durchgeführt, oder TwinCAT wird beim Herunterfahren von Windows NT sicher gestoppt. Des Weiteren werden alle Zugriffe der TwinCAT Server auf Windows NT Dienste von TwinCAT System ausgeführt. Das TwinCAT System besteht aus dem TwinCAT System Service und dem TwinCAT System Control.

Begriffe:

TwinCAT - Total Windows Control and Automation Technology

ADS - Automation Device Specification

AMS - Automation Message Specification

TwinCAT System Service

TwinCAT System Control

TwinCAT System Service

Der TwinCAT System Service arbeitet als Windows NT Dienst im lokalen Systemkonto. So wird der TwinCAT System Service von Windows NT gestartet, bevor sich ein Benutzer eingeloggt hat. Als Aktivitätszeichen blendet der TwinCAT System Service sein Icon in die Taskbar des Desktops ein. Zusätzlich wird über die Farbe des Icons der Zustand des TwinCAT Systems angezeigt.

Farbe des Icons:

Rot:

TwinCAT ist gestoppt.

Blau:

TwinCAT ist im Konfig Modus.

Gelb:

TwinCAT wird gestartet.

Grün:

TwinCAT ist gestartet.

Der TwinCAT System Service ist in erster Linie verantwortlich für den Start bzw. Stop des TwinCAT Laufzeitsystems. Er lädt alle konfigurierten Server und initialisiert diese beim TwinCAT Systemstart.

Mit einem Mausklick (links oder rechts) auf das Icon oder der Tastenkombination <ALT-+> wird das Kontextmenü des System Service angezeigt.

TwinCAT System Control

Mit TwinCAT System Control wird das TwinCAT Laufzeitsystem parametriert.

Folgende Einstellungen können vorgenommen werden:

  • Hinzufügen von TwinCAT Servern
  • Parametrieren des TwinCAT Systemstarts
  • Konfiguration von Remoteverbindungen
  • Parametrieren des Message Routers
  • Parametrieren der PLC-Laufzeitsysteme


TwinCAT und Windows NT

TwinCAT Taskausführung und Windows Ausführungszeit

Im folgenden Beispiel wird die Regelung der Taskausführungszeit von TwinCAT und die Ausführungszeit von Windows NT basierenden Betriebssystemen dargestellt:

Die folgende Grafik gibt ein Beispiel für die Ausführungszeiten wieder.

Die Ausführungszeit von NT beginnt, wenn die Taskausführung beendet ist, jedoch spätestens nach der Hälfte der Zeit (50 %). Falls die Taskausführung mehr Zeit, als die eingestellten 50 % benötigt, wird sie zu Gunsten von Windows NT unterbrochen, und im nächsten Zyklus zu Ende geführt. Wird in einem Zyklus keine Task ausgeführt, kann die Rechenzeit zu 100 % von Windows NT genutzt werden.

TwinCAT Taskausführung und Windows Ausführungszeit unter berücksichtigung verschiedener Taskprioritäten

Im folgenden Beispiel wird die Regelung der Taskausführung unter Berücksichtigung verschiedener Prioritäten und der Ausführungszeit von Windows NT basierten Betriebssystemen illustriert

Die folgende Grafik gibt ein Beispiel für die Ausführungszeiten wieder.

Die höherpriore Task1 wird mit jedem Zyklus ausgeführt. Die verbleibende Zeit zur Taskausführung wird vom Task2 (niedere Priorität) genutzt. Die Ausführungszeit von Windows NT beträgt in jedem Zyklus konstante 50 %.


Übersicht

Der TwinCAT System Service stellt sich mit folgendem Icon in der Windows NT/2000/XP Taskbar dar:

Zustand des Systems:

Mit der Hauptfarbe des Icons wird der aktuelle Zustand des System angezeigt:

Rot bedeutet: TwinCAT wird gestoppt.

Gelb bedeutet: TwinCAT wird gestartet.

Grün bedeutet: TwinCAT läuft.

Ab TwinCAT 2.9 existiert der TwinCAT Konfig Modus

Blau bedeutet: TwinCAT befindet sich im Konfig Modus

Echtzeiteinstellung:

Zusätzlich wird über einen Tooltip bei laufenden System, die aktuelle Echtzeiteinstellung angezeigt. Im gezeigten Beispiel hat das TwinCAT Echtzeitsystem maximal 50% der Prozessorleistung zur Verfügung, benötigt aber nur 0% der Prozessorleistung:

Kontextmenü:

Mit einem Mausklick (links oder rechts) auf das TwinCAT System Icon öffnet sich ein Kontextmenü, über das der Benutzer das TwinCAT System steuern kann. Die aufgelisteten Funktionen können per Maus oder Tastatur angewählt werden.

Die Menüfunktionen werden auf den nächsten Seiten im Detail erläutert.

Tastaturbedienung des TwinCAT System Benutzerinterface

Mit Alt und ( [NUM] + ) lässt sich das TwinCAT System aufrufen. Mit den Pfeiltasten kann man im Menü navigieren. mit der Return-Taste lassen sich die ausgewählten Elemente auswählen.

Damit ist es möglich, das TwinCAT System ohne Maus zu steuern.


Menü des TwinCAT System Service

Die Menüfunktionen im Detail:

Über TwinCAT…:

Mit dieser Menüzeile wird eine Beschreibung der installierten TwinCAT Version aufgerufen. Diese Informationen sind zum Beispiel bei Kontakten mit der TwinCAT Support-Hotline nützlich.

Ereignisanzeige:

Die Ereignisanzeige ist ein Programm, mit dem Sie die Ereignisse im System überwachen können. Der Ereignisprotokollierdienst startet automatisch, wenn Sie Windows NT ausführen.

System Manager:

Hiermit kann der TwinCAT System Manager gestartet werden.

PLC Control:

Hiermit kann das TwinCAT PLC Control gestartet werden.

Echtzeit:

Das TwinCAT Echtzeitsystem kann ebenfalls über das Kontextmenü konfiguriert werden. Hier betrifft dies allerdings nur die Einteilung der Prozessorleistung.

Über den Schieberegler oben im Bild, kann dem TwinCAT Echtzeitsystem Prozessorzeit zugeteilt werden. Aktuell ist hierfür eine Zeitbasis von einer Millisekunde festgelegt. Im gezeigten Beispiel bekommt TwinCAT maximal 30% der Rechenzeit zugeteilt. Dies bedeutet bei einer Zeitbasis von 1 ms, dass TwinCAT jede Millisekunde maximal 300 µs zur Verfügung hat. Auf der anderen Seite heißt dies, dass für Windows NT mindestens 700 µs verbleiben. Wenn das TwinCAT Echtzeitsystem in seine Idletask schaltet, wird der Prozessor wieder an Windows NT zurückgegeben. Der Balken im Schieberegler zeigt die aktuelle Auslastung des Echtzeitsystems an. Die Anzeige wird über 256 Zyklen (ms) gemittelt.

System Latenzzeit:

Hier werden die aktuelle bzw. die maximale Latenzzeit im Echtzeitsystem angezeigt. Es wird die Zeit gemessen, um die der zentrale Systemtick zu spät kommt. Die maximale Zeit wird solange gespeichert bis der Schieberegler betätigt wird oder der Dialog verlassen wird. Die Latenzzeit wird natürlich auch gemessen, wenn der obige Dialog nicht geöffnet ist.

Bei Überschreiten der eingestellten Maximalzeit, wird einmalig eine Meldung im Fenster ausgegeben, und ein Logbucheintrag erzeugt. Durch Aufruf des obigen Dialogs kann die Meldung wieder zurückgesetzt werden, so dass bei der nächsten Zeitüberschreitung wieder eine Meldung ausgegeben wird.

Zeitbasis:

Zeitbasis zur Berechnung der Prozenteinteilung. Zur Zeit ist eine Zeitbasis von 1 Millisekunde festeingestellt.

Router:

Der TwinCAT Message Router kann zur Diagnose seine interne Speicher- bzw. Portverwaltung darstellen. Dieser Dienst kann über das Kontextmenü aufgerufen werden.

Info

Arbeitsspeicher:

Der angezeigte Arbeitsspeicher wird im TwinCAT System für AMS-Nachrichten und für die Speicherverwaltung der TwinCAT Echtzeitumgebung benötigt. Der gesamte Speicher wird beim Start vom TwinCAT System bei Windows NT angefordert. Die Speichergröße kann im TwinCAT System Control konfiguriert werden. Der von TwinCAT benötigte Arbeitsspeicher ist nicht auslagerbar.

Arbeitsspeicher gesamt:

Der Arbeitspeicher, der beim Systemstart von TwinCAT zur Verfügung stand.

Arbeitsspeicher verfügbar:

Der Arbeitsspeicher, der aktuell für TwinCAT zur Verfügung steht.

Anmeldungen

Alle Teilnehmer des TwinCAT Nachrichtensystems (AMS) müssen sich beim Router anmelden. TwinCAT Server haben feste Portnummern (z.B. TwinCAT NC: 500, TwinCAT PLC LZS1: 801, …), TwinCAT Clients bekommen eine Portnummer vom Message Router zugeteilt.

Ports

Anzahl der angemeldeten Ports.

Server

Ports die von TwinCAT Servern belegt werden.

Transports

Internal only.

Maildebugging

In Verbindung mit dem TwinCAT Maildebugger kann der gesamte TwinCAT Nachrichtenverkehr aufgezeichnet werden. Zu beachten ist hierbei, dass der Nachrichtenverkehr durch die zusätzlichen Nachrichten verlangsamt wird. Der Maildebugger gehört nicht zum Standardlieferumfang von TwinCAT.

Cleanup

Mit der "Cleanup"-Funktion des Routers werden Ports im Router wieder freigegeben, die von nicht mehr funktionsfähigen Programmen stammen. Diese Funktion ist besonders in der Entwicklungsphase der Applikationen sinnvoll.

System:

Falls das TwinCAT System nicht für einen automatischen Start konfiguriert ist, kann der Start auch manuell über das Kontextmenü erfolgen. Die Konfiguration des automatischen Starts wird mit dem TwinCAT System Control durchgeführt. Im Kontextmenü sind nur die im aktuellen Betriebszustand sinnvollen Funktionen freigegeben. Im Beispiel befindet sich das TwinCAT System im Stopzustand, daher ist nur ein Start möglich.

Die Funktionen im Detail:

Start:

Das TwinCAT System wird gestartet. Alle eingetragenen TwinCAT Server werden geladen und initialisiert. Das TwinCAT I/O-Subsystem wird entsprechend der Konfiguration durch den TwinCAT I/O-Manager parametriert. Alle eingetragenen Laufzeitsysteme des PLC-Subsystems werden initialisiert. Ist für ein Laufzeitsystem ein Bootprojekt eingetragen, so wird dieses geladen und das SPS-Programm gestartet. Die remanenten (retain) Daten werden ebenfalls entsprechend der Konfiguration geladen. Das Bootprojekt wird mit dem TwinCAT PLC Control erzeugt. Das Startverhalten (Bootprojekt, Datenremanenz) der SPS-Laufzeitsysteme kann über das TwinCAT System Control konfiguriert werden.

Stop:

Das TwinCAT System wird gestoppt. Alle eingetragenen TwinCAT Server werden heruntergefahren und entladen. Nach dem Stop des TwinCAT Systems befindet sich nur noch der TwinCAT Message Router im Speicher. Das TwinCAT System kann nun wieder über "System ->Start" gestartet werden.

Restart:

Das TwinCAT System wird erst gestoppt und anschließend wieder gestartet. Diese Funktion ist bei Änderungen der Systemkonfiguration nützlich, da auf diesem Wege die Konfiguration durch den Neustart erneut geladen wird.

Der TwinCAT Message Router kann zur Diagnose seine interne Speicher- bzw. Portverwaltung darstellen. Dieser Dienst kann über das Kontextmenü aufgerufen werden.

IO:

Das TwinCAT I/O Subsystem kann über den TwinCAT System Service resettet werden. Dazu muss im Kontextmenü, die entsprechende Funktion angewählt werden. Der Reset gilt für alle angeschlossenen Feldbussysteme. Siehe hierzu auch die Dokumentation des TwinCAT I/O Managers.

PLC:

Über PLC wird ein Untermenü zum Starten, Stoppen und Resetten eines (der) SPS-Laufzeitsystem(e) geöffnet. Je nach Anzahl der konfigurierten SPS-Laufzeitsysteme, wird ein weiteres Untermenü zur Auswahl des Laufzeitsystems geöffnet.

Hier sind für das TwinCAT System 4 SPS-Laufzeitsysteme konfiguriert. Jedes Laufzeitsystem kann separat gesteuert werden.

Eigenschaften:

Mit der Anwahl "Eigenschaften" wird das TwinCAT System Control gestartet.


TwinCAT System Control

Das TwinCAT System Control ist eine dialogbasierte Applikation mit einer separaten Seite für jeden unterstützten Systembereich.

Karteireiter:

  • Allgemein
  • System
  • AMS Router
  • PLC
  • Registrierung

Karteireiter "Allgemein":

Auf der ersten Seite findet der Benutzer allgemeine Informationen zur installierten TwinCAT Version. Bitte geben Sie bei jedem Kontakt mit der TwinCAT Hotline, die hier eingetragenen Daten an.

Karteireiter "System":

Diese Seite zeigt die Grundkonfiguration des TwinCAT Systems. Hier können TwinCAT Server hinzugefügt bzw. entfernt werden und der automatische Systemstart (Aktiviere Auto Boot) kann aktiviert werden.

Automatischer Systemstart:

Auto Boot Disable: Der automatische Systemstart ist deaktiviert.

Auto Boot Enable: Der automatische Systemstart ist aktiviert.

Auto Boot Config Mode: Der automatische Systemstart ist aktiviert, TwinCAT startet im Config Mode.

Automatisches Einloggen aktivieren:

Mit Anwahl des Auto Logon wird das automatische Einloggen unter Windows NT aktiviert. Um das Auto Logon mehrmals durchführen zu können, muss hier der Benutzername und das Passwort eingegeben werden. Wenn an dieser Stelle kein Passwort verwendet wird, dann funktioniert das automatische Einloggen nur einmalig (Windows NT Eigenschaft).

Automatisches Einloggen aufheben:

Um das automatische Einloggen trotz der angewählten Einstellungen zu unterbrechen, muss während des Einloggens die Shift Taste gedrückt gehalten werden. Dadurch wird das Auto Logon abgebrochen und Sie können sich wie gewohnt in Windows NT einloggen.

TwinCAT kann durch zusätzliche Server erweitert werden. Dies können Nockenschaltwerke, Streckensteuerungen oder andere Softwaregeräte sein. Die Modularität von TwinCAT erlaubt es nun, diese Server durch einfache Konfiguration in das TwinCAT System zu laden. Bedingung ist allerdings, dass der Server mit dem TwinCAT Server Framework erstellt wurde. Für Windows NT stellen sich TwinCAT Server als Gerätetreiber dar, so kann der Betriebszustand der TwinCAT Server auch in der Geräteliste von Windows NT ersehen werden.

Achtung!

Änderungen auf der Systemseite sollten nur von erfahrenen TwinCAT Benutzern oder unter Anleitung des TwinCAT Supports durchgeführt werden.

TwinCAT Server zufügen

Diese Funktion ist notwendig, wenn ein TwinCAT Server nicht durch die Standardinstallation beim System angemeldet wird. Dies kann bei applikationsspezifischen TwinCAT Servern der Fall sein.

Name

Dies ist der Windows NT Gerätename. Mit diesem Namen wird der TwinCAT Server von Windows NT angesprochen. Bei TwinCAT Servern entspricht der Gerätename dem Dateinamen des TwinCAT Servers.

Anzeigename

Dient nur zur Anzeige im Windows NT System und kann frei vergeben werden.

Dateipfad

Pfad zur Binärdatei des TwinCAT Servers.

Type

Derzeit können nur Windows NT Treiber als TwinCAT Server fungieren, deshalb ist hier "DriverType" einzutragen. In Zukunft werden auch Win32 Dienste als TwinCAT Server arbeiten können.

Startmodus

TwinCAT Server werden vom TwinCAT System Service gestartet, daher ist die Standardeinstellung hier "manual". Für spezielle TwinCAT Server könnte ein Start über Windows NT nötig sein, daher kann hier der Startmodus geändert werden.

TwinCAT Server entfernen:

Wenn der folgende Dialog mit OK quittiert wird, ist der TwinCAT Server aus dem TwinCAT System sowie aus Windows NT entfernt. Die Binärdatei des TwinCAT Servers wird allerdings nicht von der Festplatte gelöscht.

Eigenschaften eines TwinCAT Servers

Der Dialog wird durch Doppelklick auf den Servernamen in der Serverliste oder durch Betätigen des Buttons "Eigenschaften" geöffnet.

In diesem Dialog können die Eigenschaften eines TwinCAT Servers (z.B. der Pfad) nachträglich angepasst werden.

Karteireiter "AMS Router":

In den Einstellungen für den AMS Message Router werden die lokale Maschinenadresse und die Verbindungen zu anderen TwinCAT Systemen festgelegt.

AMS Net Id

Dies ist die Adresse des lokalen Rechners im TwinCAT Netzwerk. Die "AMS Net Id" besteht aus 6 Byte und wird in einer Punktnotation dargestellt. Die "Net Ids" müssen vom Projektierer vergeben werden und dürfen sich im TwinCAT Netzwerk nicht wiederholen. Standardmäßig wird von der Installation eine AMS Net Id aus der IP-Adresse des Systems (falls vorhanden) + "1.1" generiert. Kann bei der Installation keine IP-Adresse ermittelt werden, so wird die AMS Net Id "1.1.1.1.1.1" erzeugt.

Remote Computer

Liste der erreichbaren TwinCAT Systeme im TwinCAT Netzwerk.

Remote Verbindung hinzufügen:

Mit dem Button "Hinzufügen" wird folgender Dialog geöffnet.

Hier lassen sich neue Verbindungen mit anderen TwinCAT Systemen konfigurieren.

Browse:

Über diesen Dialog kann nach dem Remote-Rechner gesucht werden. Nach der Auswahl des Remote-Rechners wird die IP-Adresse geholt und die AMA Net Id automatisch generiert. Diese Net Id entspricht der Standard Net Id nach der Installation.

Name

Symbolischer Name des entfernten TwinCAT Systems. Dieser Name kann frei vergeben werden.

AMS Net Id

Adresse des entfernten TwinCAT Systems.

Adresse

Systemadresse bezogen auf die jeweilige Transportschicht. Im obigen Beispiel wird TCP/IP als Transportschicht benutzt, womit die Adresse als IP-Adresse interpretiert wird.

Transport

Die Transportschicht mit der AMS Nachrichten befördert werden. Zur Zeit wird nur TCP/IP als Transportschicht unterstützt.

Langsame Verbindung

Option damit das Betriebssystem längere Latenzzeiten toleriert.

Entfernen eines Systems aus der Remote Liste

Nach Quittieren dieses Dialoges ist "Maschine" unwiderruflich aus der Remote Liste entfernt.

Eigenschaften der Remote Verbindung

Mit diesem Dialog kann eine Remote-Verbindung nachträglich angepasst werden.

Weitere Informationen zur Remote Verbindung sind in der Dokumentation TwinCAT Remote Access Service enthalten.

Karteireiter "PLC":

Mit der PLC-Seite des TwinCAT System Control wird das PLC-Subsystem konfiguriert.

Anzahl Laufzeitsysteme

Das TwinCAT PLC-Subsystem unterstützt bis zu 4 Laufzeitsysteme. Die Anzahl der Laufzeitsysteme wird über das oben gezeigte Steuerelement eingestellt.

Boot Projekt Pfad

Für jedes PLC-Laufzeitsystem kann ein separates Bootprojekt erzeugt werden. Der Pfad aus dem das Bootprojekt geladen werden soll, muss hier konfiguriert werden.

Durchsuchen

Zur Unterstützung des Benutzers kann der Bootprojektpfad auch über diesen Dialog eingetragen werden.

Boot Projekt

Für jedes Laufzeitsystem kann separat das Laden eines Bootprojekts aktiviert werden. Durch einen Mausklick auf die entsprechende Zeile wird das Bootprojekt eines Laufzeitsystems aktiviert oder deaktiviert. Zum Erzeugen eines Bootprojekts starten Sie bitte das TwinCAT PLC Control, im Online-Menü finden Sie die Anwahl "Erzeugen eines Bootprojekts.

Laden/Speichern der Retain Daten

Falls ein Bootprojekt für ein Laufzeitsystem angewählt ist, können für dieses Laufzeitsystem auch remanente Daten geladen bzw. geschrieben werden. Diese Option kann über die Auswahlbox an- bzw. abgewählt werden.

Karteireiter "Registrierung":

TwinCAT Version

Vorliegende Produktversion.

System Id

Eindeutiges Kennzeichen des lokalen Systems, diese Zahlenkombination geben Sie bitte bei der Registrierung von TwinCAT an.

Registrierung

Der Registrierungsschlüssel, der zur TwinCAT Version und der ermittelten System ID passt. Diesen Schlüssel erhalten Sie bei der Registrierung von TwinCAT.

Online

Zur Zeit nicht unterstützt.

Fon

Rufnummer zur Registrierung von TwinCAT.